<template>
  <aside
    :class="[
      'fixed top-0 left-0 bottom-0 transition-all bg-gray-300 flex flex-col bg-ground-50 shadow-card_3',
      { 'w-60 p-4': isOpen || isSlide },
      { 'p-1 w-10': !isOpen && !isSlide },
    ]"
  >
    <div class="mb-4 w-full aspect-square rounded-full bg-primary-30">
      <inline-svg
        src="../../../src/static/img/sport.svg"
        class="w-full h-full fill-primary-100"
      ></inline-svg>
    </div>
    <button
      :class="[
        'flex rounded-xl items-center hover:bg-primary-40 hover:text-primary-100 transition-all',
        { 'justify-center w-8 h-8': !isOpen && !isSlide },
        { 'py-2 px-3 gap-2': isOpen || isSlide },
      ]"
      @click="toggleMenu"
    >
      <DArrowRight
        :class="['flex-shrink-0 transition-all h-7', { 'rotate-180': isOpen }]"
      />
      <span :class="[{ 'w-0 overflow-hidden h-0': !isOpen && !isSlide }]">{{
        btnText
      }}</span>
    </button>
    <ul class="flex flex-col gap-1 border-t-2 pt-2 mt-2 border-primary-30">
      <li v-for="el in menu" :key="el.code">
        <router-link
          :to="el.link"
          :class="[
            'flex rounded-xl items-center hover:bg-primary-40 hover:text-primary-100 transition-all ',
            { 'justify-center w-8 h-8': !isOpen && !isSlide },
            { 'py-2 px-3 gap-2': isOpen || isSlide },
          ]"
          ><component :is="el.component" class="h-7" /><span
            :class="[{ 'w-0 overflow-hidden h-0': !isOpen && !isSlide }]"
            >{{ el.name }}</span
          ></router-link
        >
      </li>
    </ul>
    <button
      :class="[
        'flex rounded-xl items-center hover:bg-primary-40 hover:text-primary-100 transition-all mt-auto',
        { 'justify-center w-8 h-8': !isOpen && !isSlide },
        { 'py-2 px-3 gap-2': isOpen || isSlide },
      ]"
      @click="toggleMenu"
    >
      <SwitchButton class="h-7" />
      <span :class="[{ 'w-0 overflow-hidden h-0': !isOpen && !isSlide }]"
        >Выйти</span
      >
    </button>
  </aside>
</template>

<script setup lang="ts">
import { useAside } from "../../store/aside";
import { storeToRefs } from "pinia";
import { computed } from "vue";
import {
  User,
  List,
  Star,
  TrophyBase,
  Histogram,
  InfoFilled,
  SwitchButton,
  DArrowRight,
  Files,
} from "@element-plus/icons-vue";

const menu = [
  {
    link: "/",
    name: "Личный кабинет",
    code: "main",
    component: User,
  },
  {
    link: "/training",
    name: "Список тренировок",
    code: "training",
    component: List,
  },
  {
    link: "/turnament",
    name: "Список турниров",
    code: "turnament",
    component: TrophyBase,
  },
  {
    link: "/rating",
    name: "Рейтинг игроков",
    code: "rating",
    component: Star,
  },
  {
    link: "/news",
    name: "Новости",
    code: "news",
    component: Histogram,
  },
  {
    link: "/about",
    name: "О проекте",
    code: "about",
    component: InfoFilled,
  },
  {
    link: "/ui-kit",
    name: "Элементы системы",
    code: "uikit",
    component: Files,
  },
];

const store = useAside();

const { isOpen, isSlide } = storeToRefs(store);

const toggleMenu = () => {
  store.isOpen = !store.isOpen;
  store.isSlide = false;
};

const btnText = computed(() => {
  return !store.isOpen ? "Раскрыть меню" : "Свернуть меню";
});
</script>
